<?php
require_once ('interfaces/EventListener.php');
require_once ('interfaces/VirusFilter.php');
require_once ('kavmng.php' );


class kavListener implements EventListener {
	function handleEvent($object_type, $object_id, $action, $old_values, $new_values)
	{
		$components = getComponentNames();

		$AL = $components[COMP_MAIL_ALIAS];
		$DA_MAIL = $components[COMP_DOMAIN_ALIAS_MAIL];
		$CSTATUS = $components[COMP_STATUS];
		$C_DOM_ID = $components[COMP_DOMAIN_ID];
		if ($action == 'mailname_update' && isset($old_values[$AL])
		   && $old_values[$AL] == ''
		   && ($new_alias = $new_values[$AL]) != ''
		   && array_key_exists('Antivirus', $new_values)
		   && ($av_status = $new_values['Antivirus']) != VirusFilterUserController::STATUS_NONE) {
			// new alias created, create handler(s)
			$dname = $new_values[$components[COMP_DOMAIN_NAME]];
			$dom_id = $new_values[$C_DOM_ID];

			$mng = new kavmng;
			foreach (kavmng::getAllDomains($dom_id, $dname) as $dom) {
				$mng->applyStatus($av_status, $new_alias . '@' . $dom);
			}
		} else if (($action == 'domain_alias_update'
			|| $action == 'domain_alias_create')
                    && $new_values[$DA_MAIL] == 'true'
                    && $new_values[$CSTATUS] == STATUS_ACTIVE
		    && ($old_values[$DA_MAIL] != 'true' || $old_values[$CSTATUS] != STATUS_ACTIVE)
		    ) {
			// either new alias with mail support is created
			// or mail support is activated on existing domain alias

			$dom_id = $new_values[$C_DOM_ID];
			$domalias = $new_values[$components[COMP_DOMAIN_ALIAS_NAME]];

			$mng = new kavmng;
			foreach (kavmng::getAllMails($dom_id) as $ma) {
				$mng->applyStatus($ma['filter'], $ma['name'] . '@' . $domalias);
			}

		}
	}
};

return VirusFilterManager::getActive() == 'kav' ? new kavListener : NULL;

?>
